# -*- coding: utf-8 -*-
"""
Created on Sun May 13 13:50:12 2018

@author: Cliff
"""
import numpy as np
import networkx as nx


def get_network(frn):
    ### original network
    #frn="./dat/DIP20101010.txt"
    fr = open(frn, 'r')
    lines = [line.strip() for line in fr.readlines()]
    fr.close()

    G = nx.Graph()

    for k in range(len(lines)):
        if lines[k]:
            u, v = lines[k].split()
            G.add_node(u)
            G.add_node(v)
            G.add_edge(u, v)
    #print(G.number_of_nodes())
    return (G)


def get_essential(frn):
    #frn="./dat/Essenntial(DIP20101010).txt"
    fr = open(frn, 'r')
    ess_pros = [line.strip() for line in fr.readlines()]
    fr.close()
    ###list
    return (ess_pros)


def try_read_cor(frn):
    fr = open(frn, 'r')
    mydat = []
    lines = [line.strip() for line in fr.readlines()]
    fr.close()
    rownames = []
    for k in range(len(lines)):
        if lines[k]:
            if lines[k][0] == '#':
                header = lines[k].split(',')[1:]  # protein;label;features...
            elif lines[k][0] != '#':
                aline = lines[k].split(',')
                bline = []
                ## 1st column is node name
                for j in range(len(aline)):
                    if j == 0:  #row name
                        rownames.append(aline[j])  #proteins ID
                    else:  #j==1 is label
                        bline.append(float(aline[j]))
                mydat.append(bline)
    mydat = np.array(mydat, dtype=float)
    #header=header[1:] #remove label; keep only features
    #rownames=rownames[1:] #only proteinIDs
    return (mydat, header, rownames)


def scale_model_api(mydat, rownames, fwn, myheader):
    ### scale feature into (0,1)
    mydat = np.array(mydat, dtype=float)

    ####
    amax = np.max(mydat, axis=0)
    amin = np.min(mydat, axis=0)
    print(amax)
    print(amin)
    arng = amax - amin
    print(arng)
    row, col = mydat.shape
    bdat = np.zeros((row, col))
    for i in range(row):
        for j in range(col):
            if arng[j] == 0:
                bdat[i][j] = 0
                print(j, "zero")
            else:
                bdat[i][j] = (mydat[i][j] - amin[j]) * 1.0 / arng[j]
            #bdat[i][j]=mydat[i][j]/amax[j]
    xbdat = np.column_stack((rownames, bdat))
    np.savetxt(fwn, xbdat, fmt="%s", delimiter=",", header=myheader)

    return (bdat)


def my_rank(scores, label, maxFlag):
    ### output top100/200/.../600; top1%,5%,...25%.
    ### results
    scores = np.array(scores, dtype=float)
    label = np.array(label, dtype=int)
    results = []
    if maxFlag:
        sort_idxes = np.argsort(-scores)  #decrease
    else:
        sort_idxes = np.argsort(scores)  #increase , less better
    #### top
    top1s = [100, 200, 300, 400, 500, 600]
    top2s = [0.01, 0.05, 0.10, 0.15, 0.20, 0.25]
    #### print top-n
    for item in top1s:
        top_idxes = sort_idxes[0:item]
        top_label = list(label[top_idxes])
        mycount = top_label.count(1)
        #print("Top %3d: %3d" %(item,mycount))
        #print(top_label)
        results.append((item, mycount))
    #### print top-%
    #print("##### percent")
    for item in top2s:
        nn = int(np.ceil(item * len(label)))  # ceiling
        #print(type(nn))
        top_idxes = sort_idxes[0:nn]
        top_label = list(label[top_idxes])
        mycount = top_label.count(1)
        #print("Top %.2f %4d %3d" %(item,nn,mycount))
        results.append((nn, mycount))
    topn = []
    for k in range(len(top1s)):
        topn.append(results[k][1])  #results[0:len(top1s)]
    #print(topn)
    # 2*y1+...+2*y5+y6 /  (3600)
    qscore = (sum(topn) + sum(topn[0:-1])) * 1.0 / 3600  # area ration
    return ((results, qscore))
