# -*- coding: utf-8 -*-
"""
Created on Wed Jun 07 16:59:49 2017

@author: Cliff
"""
import networkx as nx
from numpy.linalg import inv
import numpy as np

#current_flow_closeness_centrality = information centrality


def get_subgraph_centrality(G):
    """ return subraph centrality for each node"""
    import numpy
    import numpy.linalg
    nodelist = list(G)  # ordering of nodes in matrix
    #print(nodelist)
    A = nx.to_numpy_matrix(G, nodelist)
    #print(A)
    # convert to 0-1 matrix
    A[A != 0.0] = 1
    w, v = numpy.linalg.eigh(A.A)
    vsquare = numpy.array(v)**2
    expw = numpy.exp(w)
    xg = numpy.dot(vsquare, expw)
    # convert vector dictionary keyed by node
    sc = dict(zip(nodelist, map(float, xg)))
    return sc


#G = nx.Graph([(1,2),(1,5),(1,8),(2,3),(2,8),(3,4),(3,6),(4,5),(4,7),(5,6),(6,7),(7,8)])
#sc = get_subgraph_centrality(G)
#print(G.degree())
#print(['%s %0.2f'%(node,sc[node]) for node in sc])
#['1 3.90', '2 3.90', '3 3.64', '4 3.71', '5 3.64', '6 3.71', '7 3.64', '8 3.90']


#getIC()
def get_LAC(G):
    """### local average connectivity SUM_{w in Nu} {deg_cu(w)} / |Nu|"""
    ####  ### not inlcude u
    LACDB = {}

    for u in G.nodes():
        ## get the subgraph
        xx = G.neighbors(u)
        #xx.append(u)### including u in subgraph of u
        g2 = G.subgraph(xx)
        #g2=subgraph(G,u)
        #print(u,xx,g2.number_of_edges(),g2.number_of_nodes())
        fenzi = sum(g2.degree().values())
        fenmu = g2.number_of_nodes()
        if fenmu == 0:
            alac = 0.0
        else:
            alac = fenzi * 1.0 / fenmu
        LACDB[u] = alac
        #print("***",fenzi,fenmu)
    return (LACDB)


def my_get_adj(G):
    ### Information centrality
    row = col = G.number_of_nodes()
    nodeNames = G.nodes()
    #print(nodeNames)
    ### adjacency matrix of a network
    AA = np.zeros((row, col))
    edge_list = G.edges()
    for k in range(len(edge_list)):
        if len(edge_list[k]) > 0:
            start, end = edge_list[k]
            sidx = nodeNames.index(start)
            eidx = nodeNames.index(end)
            AA[sidx][eidx] = 1
            AA[eidx][sidx] = 1
    #print(AA)
    return (AA, nodeNames)


def get_IC(G):
    ### Information centrality
    row = col = G.number_of_nodes()
    nodeNames = G.nodes()
    print(nodeNames)
    #diagonal matrix
    DD = np.zeros((row, col))
    for anode, adegree in G.degree().items():
        idx = nodeNames.index(anode)
        DD[idx][idx] = adegree
    ### ones
    JJ = np.ones((row, col))
    ### adjacency matrix of a network
    AA = np.zeros((row, col))
    edge_list = G.edges()
    for k in range(len(edge_list)):
        #[start,end]=edge_list[k] #[ [v1,v2],[v3,v4]]
        #print(k,edge_list[k])
        if len(edge_list[k]) > 0:
            start, end = edge_list[k]

            sidx = nodeNames.index(start)
            eidx = nodeNames.index(end)
            AA[sidx][eidx] = 1
            AA[eidx][sidx] = 1
    print(AA)
    ###
    CC = inv(DD - AA + JJ)
    ST = np.trace(CC)
    DA = np.diag(CC)
    RR = np.sum(CC, axis=1)[0]  #Row Sum
    xIC = 1.0 / (DA + (ST - 2.0 * RR) / row)
    print("xic", xIC)
    ICDB = {}
    for u in G.nodes():
        ICDB[u] = 0.0
        tmpsum = 0.0
        for v in G.nodes():
            if True:  #v!=u: #True:
                idx = nodeNames.index(u)
                idy = nodeNames.index(v)
                tmpsum += (CC[idx][idx] + CC[idy][idy] - 2 * CC[idx][idy])
        ###
        try:
            ICDB[u] = row * 1.0 / (tmpsum)
        except ZeroDivisionError:
            ICDB[u] = 0.0
            print("node number is 0")

    return (ICDB)


if False:
    G = nx.Graph()

    G.add_edge(1, 2)
    G.add_edge(2, 3)
    G.add_edge(2, 11)

    G.add_edge(3, 4)
    G.add_edge(3, 6)
    G.add_edge(3, 7)
    G.add_edge(3, 13)
    G.add_edge(3, 14)
    G.add_edge(4, 5)
    G.add_edge(7, 8)
    G.add_edge(8, 9)
    G.add_edge(8, 15)
    G.add_edge(9, 10)
    G.add_edge(10, 11)
    G.add_edge(10, 15)

    G.add_edge(11, 12)
    G.add_edge(11, 13)
    G.add_edge(13, 14)
    G.add_edge(14, 15)

    G.add_edge(2, 3)
    G.add_edge(3, 4)

    #print(G.number_of_edges(),G.number_of_nodes())
    print(get_IC(G))
    G2 = nx.Graph()
    G2.add_edge(1, 2)
    G2.add_edge(2, 3)

    #G2.add_edge(1,3)
    G2.add_node(4)
    print("++++++")
    print(G2.edges())
    subgraphs = list(nx.connected_component_subgraphs(G2))
    res = {1: 0, 2: 0, 3: 0, 4: 0}
    for graph in subgraphs:
        bet = nx.current_flow_closeness_centrality(graph)
        print(graph, bet)
        res.update(bet)
    #print(res)
    #print(nx.current_flow_closeness_centrality(G2.subgraph([1,2,3])))
    print(get_IC(G2))
if False:
    G = nx.Graph()
    # 添加边(i, j)时保证i < j
    G.add_edge(1, 2)
    G.add_edge(3, 2)
    G.add_edge(1, 3)
    G.add_edge(1, 4)
    print(get_LAC(G))
    #print(LAC(G, u))