# -*- coding: utf-8 -*-
"""
Created on Wed May 24 06:38:35 2017

@author: Cliff
"""
import numpy as np
from scipy import stats


def rank_features(X, Y):
    ### rank the features
    X = np.array(X, dtype=float)
    Y = np.array(Y, dtype=float)
    row, col = X.shape

    cors = []  #pointbiserialr
    pccs = []  #spearman
    spcs = []
    for j in range(col):
        afeature = X[:, j]
        acor = stats.pointbiserialr(afeature, Y)[0]  #corr/pvalue
        bcor = stats.pearsonr(afeature, Y)[0]
        ccor = stats.spearmanr(afeature, Y)[0]
        cors.append(acor)
        pccs.append(bcor)
        spcs.append(ccor)

    return (cors, pccs, spcs)


def get_rank_of_features(frn, fwn):
    #frn="model.features.scale.csv"
    #fwn="rank.features.csv"
    fw = open(fwn, 'w')
    fw.write("#name,index,biserialr,pcc,spc\n")
    #frn=open(frn,'r')
    mydat = np.loadtxt(frn, delimiter=",", dtype=object, comments='#')
    print(mydat.shape)
    X = mydat[:, 2:]  #0 node name  1 label
    Y = mydat[:, 1]  # 0 node name
    fr = open(frn, 'r')
    fristline = fr.readline().strip()
    colnames = fristline.split(',')[2:]
    print(colnames)
    mycors, mypccs, myspcs = rank_features(X, Y)
    for k in range(len(mycors)):
        fw.write("%s,%d,%f,%f,%f\n" % (colnames[k], k, mycors[k], mypccs[k],
                                       myspcs[k]))
    fw.close()
    X = np.array(X, dtype=float)
    mycor = np.corrcoef(X, rowvar=0)  ## column vector
    myheader = ','.join(colnames)
    np.savetxt(
        "../cor.withfeature.csv",
        mycor,
        header=myheader,
        delimiter=',',
        fmt="%f")


#main()
