# -*- coding: utf-8 -*-
"""
Created on Sun May 13 13:41:39 2018

@author: Cliff
"""
import sys
import networkx as nx
import numpy as np
from api_gene import refine_network_subloc, get_gene_db, refine_network_gene
from api_gene import get_ECCGENE_DB
from getIC import get_subgraph_centrality
from api_header4standalone import get_network, get_essential, my_rank
from api_header4standalone import scale_model_api

import os
import sys
from orders import get_order_predictions, get_predictions, get_pvalues
from rank import evaluate_predictions, evaluate_predictions_4nx


def get_features(netfn,
                 fwn,
                 refineFlag,
                 ess_file="../dat/EssentialProteins.txt"):
    #### input netowrks output each node: score1,score2,...scoren
    gene_file = "../dat/genedata.txt"
    sublocf = "../dat/subcellular.txt"
    PCCFlag = True  #False
    #####
    G = get_network(netfn)
    print("orignal_network nodes: %d  edges: %d " % (G.number_of_nodes(),
                                                     G.number_of_edges()))
    if refineFlag:
        ### refine networks
        G0 = refine_network_gene(G, gene_file)
        G_rf = refine_network_subloc(G0, sublocf)
        print("network(rf by gene)        nodes: %d  edges: %d " %
              (G0.number_of_nodes(), G0.number_of_edges()))
        print("network(rf by sublocation) nodes: %d  edges: %d " %
              (G_rf.number_of_nodes(), G_rf.number_of_edges()))
        fwn_refine = os.path.join(
            os.path.dirname(fwn),
            "%s.refine.network.txt" % (os.path.basename(os.path.splitext(netfn)[0])))
        nx.write_adjlist(G_rf, fwn_refine)
    else:
        G_rf = G
    #"""
    if ess_file != "None":
        ess_pros = get_essential(ess_file)
    else:
        ess_pros = []
    #### compute the property of networks
    ### degree    Key: protein value: degree  #mydegrees=G.degree()
    #### degreee centrality
    ### subgraph centrality
    mysc = get_subgraph_centrality(G_rf)  #nx.subgraph_centrality(G)
    ### get local average connectivity SUM_{w in Nu} {deg_cu(w)} / |Nu|
    ##### compute the gene Correlation

    geneDB = get_gene_db(G_rf, gene_file)
    WFlag = False
    my_ecc_gene = get_ECCGENE_DB(G_rf, geneDB, PCCFlag, WFlag)
    WFlag = True
    my_ecc_geneW = get_ECCGENE_DB(G_rf, geneDB, PCCFlag, WFlag)

    #get_ECCblast_DB(G_rf,)
    fw = open(fwn, 'w')
    fw.write("#name,label,SC,PeC,NCgeneW\n")

    labels = []
    rownames = []
    sc, ncgene, ncgeneW = [], [], []
    for u in G_rf.nodes():
        rownames.append(u)
        if u in ess_pros:
            labels.append(1)
        else:
            labels.append(0)
        sc.append(mysc[u])
        ncgene.append(my_ecc_gene[u])
        ncgeneW.append(my_ecc_geneW[u])
    # write files
    for k in range(len(labels)):
        fw.write("%s,%d,%f,%f,%f\n" % (rownames[k], labels[k], sc[k],
                                       ncgene[k], ncgeneW[k]))
    fw.close()
    labels = np.array(labels, dtype=int)
    XX = np.column_stack((sc, ncgene, ncgeneW))
    return ((labels, XX, rownames))


# stand-alone version for ensemble method
def test_main(netfn, fwn, fwn2scale, essfn, Pnum, refineFlag):
    #refineFlag=True
    #netfn=#"../2017CoTB/YDIP.txt"#"../2017PEMC/krogan.txt"
    #fwn=#"%s/CoTB_ydip.ori.part1.csv" %folder
    fwn2 = fwn2scale  #"%s/CoTB_ydip.ori.scale.csv" %folder
    #essfn=#"../2017CoTB/OnlyEssential.txt"
    #Pnum=1130#1167
    labels, XX, rownames = get_features(netfn, fwn, refineFlag, essfn)
    #mydata=np.column_stack()
    rownamesLabels = np.column_stack((rownames, labels))
    myheader = "proID,label,SC,PeC,NCgeneW"
    XXscale = scale_model_api(XX, rownamesLabels, fwn2, myheader)

    wfnFlag = False
    mFlag = "order"
    maxFlag = True

    predicts = get_predictions(XXscale, labels, wfnFlag, mFlag, Pnum)
    xresults, xarea = my_rank(predicts, labels, maxFlag)
    #[tp,fn,fp,tn,p,n,ACC,Sn,Sp,MCC,Precision,F_measure,ppv,npv]
    confuse = evaluate_predictions_4nx(predicts, labels, wfnFlag, Pnum,
                                       maxFlag)

    print(xresults, xarea)
    print(confuse)
    ## write the prediction
    xtmp = np.column_stack((rownames, labels, predicts))
    best_label_csv = os.path.join(
            os.path.dirname(fwn),
            "%s.out.best.label.pred.csv" % (os.path.basename(os.path.splitext(netfn)[0])))
    np.savetxt(best_label_csv, xtmp, fmt="%s", delimiter=",")
    
    print("outfile: %s" % best_label_csv)
    return (0)


def main(path, tag):
    if tag == '1':
        netfn = os.path.join(path, "dat/YDIP.txt")
        fwn = os.path.join(path, "output/YDIP.features.csv")
        fwn2scale = os.path.join(path, "output/YDIP.features.scale.csv")
        essfn = os.path.join(path, "dat/EssentialProteins.txt")
        Pnum = 1130
        refineFlag = True
        test_main(netfn, fwn, fwn2scale, essfn, Pnum, refineFlag)
    elif tag == '2':
        netfn = os.path.join(path, "dat/YDIP_5093.txt")
        fwn = os.path.join(path, "output/YDIP_5093.features.csv")
        fwn2scale = os.path.join(path, "output/YDIP_5093.features.scale.csv")
        essfn = os.path.join(path, "dat/EssentailProteins_1167.txt")
        Pnum = 1167
        refineFlag = True
        test_main(netfn, fwn, fwn2scale, essfn, Pnum, refineFlag)
    elif tag == '3':
        netfn = os.path.join(path, "dat/YBioGRID.txt")
        fwn = os.path.join(path, "output/YBioGRID.features.csv")
        fwn2scale = os.path.join(path, "output/YBioGRID.features.scale.csv")
        essfn = os.path.join(path, "dat/EssentialProteins.txt")
        Pnum = 1199  #1130
        refineFlag = True
        test_main(netfn, fwn, fwn2scale, essfn, Pnum, refineFlag)


if __name__ == '__main__':
    PATH = os.path.dirname(os.path.dirname(
        os.path.realpath(__file__)))  # locate to the path of "README.txt"
    print("############# Help #########")
    print("python2 standalone.py tag")
    print("tag=1, means YDIP_4746.")
    print("tag=2, means YDIP_5093.")
    print("tag=3, means YBioGRID.")
    print("############################")
    if len(sys.argv) != 2:
        sys.exit("error input.")
    else:
        main(PATH, sys.argv[1])
