# -*- coding: utf-8 -*-
"""
Created on Wed Jul 05 06:09:17 2017

@author: Cliff
"""


def read_blast_file(frn):
    fr = open(frn, 'r')
    lines = [line.strip() for line in fr.readlines()]
    fr.close()

    findFlag = False
    for k in range(len(lines)):
        if len(lines[k]) > 0:
            if lines[k][0:6] == 'Query=':
                query = lines[k].split()[1]
            if lines[k][0:19] == "Sequences producing":
                current = lines[k + 2]
                tt = k + 2
                while (current[0] != '>'):
                    aaline = current.split()
                    ahit = aaline[0]
                    if aaline[-1][0] == 'e':
                        aeval = float('1' + aaline[-1])
                    else:
                        aeval = float(aaline[-1])
                    if ahit != query:
                        findFlag = True
                        break
                    tt = tt + 1
                    current = lines[tt]
                    if len(current) > 0:
                        pass
                    else:
                        break
            if findFlag:
                break
            if lines[k][0] == '>':
                break

    return (query, ahit, aeval)


import math


def get_all_evalues(frn, fwn):
    fr = open(frn, 'r')
    lines = [line.strip() for line in fr.readlines()]
    fr.close()

    fw = open(fwn, 'w')
    for line in lines:
        if len(line) > 0:
            xfrn = "../dat/blast_out/%s.out" % line
            #frn="../dat/blast_out/YBR013C.out"
            u, v, evalue = read_blast_file(xfrn)
            fw.write("%s %s %s " % (u, v, evalue))
            try:
                logevalue = -math.log(evalue, 10)
            except ValueError:
                logevalue = 0.0
                print(u, v, evalue)
            fw.write("%f\n" % logevalue)
    fw.close()

    return (0)


#frn="../dat/nodes.txt"
#fwn="../dat/blast.evalue.txt"
#get_all_evalues(frn,fwn)
def get_evalues_db(transFlag):
    frn = "../dat/blast.evalue.txt"
    fr = open(frn, 'r')
    lines = [line.strip() for line in fr.readlines()]
    fr.close()
    EvalueDB = {}
    for line in lines:
        if len(line) > 0:
            aline = line.split()
            u = aline[0]
            v = aline[1]
            xevalue = float(aline[2])
            if transFlag:  # log
                try:
                    evalue = -math.log(xevalue, 10)
                except ValueError:
                    evalue = 180  #max mumal
            else:  #use cutoff
                if xevalue < 0.0001:
                    evalue = 1
                else:
                    evalue = 0
            if u not in EvalueDB:
                EvalueDB[u] = {}

                EvalueDB[u][v] = evalue
            else:
                EvalueDB[u][v] = evalue
    return (EvalueDB)


#aa=get_evalues_db()
#print(aa['YJR002W']['YJR002W'])
#print(aa['YLR258W']['YFR015C'])
